package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.KeyPageOperation;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: KeyPageOperationType
// UnionValue: SetThreshold

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("SetThresholdKeyPageOperation")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class SetThresholdKeyPageOperation implements KeyPageOperation {
	public final KeyPageOperationType type = KeyPageOperationType.SET_THRESHOLD;
	private long threshold;

    //
	public long getThreshold() {
	    return threshold;
	}
	public void setThreshold(final long value) {
	    this.threshold = value;
	}

	public SetThresholdKeyPageOperation threshold(final long value) {
	    setThreshold(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.threshold == 0)) {
            marshaller.writeUint(2, this.threshold);
        }
        return marshaller.array();
    }
}
